package ru.ulstu.services;

import org.springframework.stereotype.Service;
import ru.ulstu.models.TimeSeries;
import ru.ulstu.models.TimeSeriesValue;
import ru.ulstu.tsMethods.exponential.NoTrendNoSeason;

import java.time.LocalDate;


@Service
public class TimeSeriesService {
    public TimeSeries getRandomTimeSeries(int length) {
        TimeSeries ts = new TimeSeries("Random time series");
        LocalDate dateStart = LocalDate.now().minusDays(length);
        for (int i = 0; i < length; i++) {
            ts.getValues().add(new TimeSeriesValue(dateStart, Math.random()));
            dateStart = dateStart.plusDays(1);
        }
        return ts;
    }

    public TimeSeries getForecast(TimeSeries timeSeries) {
        NoTrendNoSeason nn = new NoTrendNoSeason(timeSeries, 5);
        nn.setAlpa(0.1);
        nn.createModel();
        return nn.getForecastTimeSeries();
    }
}
