package ru.ulstu.tsMethods;

import ru.ulstu.models.TimeSeries;

import java.util.HashMap;
import java.util.Map;

public abstract class TimeSeriesMethod {
    protected TimeSeries originalTimeSeries;
    protected TimeSeries modelTimeSeries;
    protected TimeSeries forecastTimeSeries;
    protected int countForecast;
    protected Map<Param, Double> parameters = new HashMap<>();

    protected void init() {
        modelTimeSeries = new TimeSeries("Model time series of '" + originalTimeSeries.getName() + "'");
        forecastTimeSeries = new TimeSeries("Forecast time series of '" + originalTimeSeries.getName() + "'");
    }

    public TimeSeries getOriginalTimeSeries() {
        return originalTimeSeries;
    }

    public TimeSeries getModelTimeSeries() {
        return modelTimeSeries;
    }

    public int getCountForecast() {
        return countForecast;
    }

    public TimeSeries getForecastTimeSeries() {
        return forecastTimeSeries;
    }

    public abstract void createModel();
}
